// 001 u_c_net_log
// 29 oct 2004

// -- (C) John COLIBRI 2004
// -- documentation: http://www.jcolibri.com

// -- a file with persistent data, from call to call

(*$r+*)

unit u_asp_net_data_log;
  interface

    const k_full_file_name= 'c:\prog\essais_util\web\_starter_kit\p_asp_portal\_exe\log\data_log.bin';
    type t_data_log= Record
                       m_sequence: Integer;
                     end;

    function f_data_log: t_data_log;

  implementation
    Uses
       system.io
       , u_c_asp_net_log
       ;

    function f_data_log: t_data_log;
      var l_c_stream: System.Io.FileStream;
          l_c_stream_reader: BinaryReader;
          l_c_stream_writer: BinaryWriter;
          l_data_log: t_data_log;
      begin

        if &File.Exists(k_full_file_name)
          then begin
              write_to_asp_net_log('data_exists');
              l_c_stream:= FileStream.Create(k_full_file_name,
                    FileMode.Open, FileAccess.ReadWrite);

              // -- read and return the result
              l_c_stream_reader:= BinaryReader.Create(l_c_stream);
              // l_c_stream_reader.Read(l_integer); // Result.m_sequence);
              Result.m_sequence:= l_c_stream_reader.ReadInt32();

              write_to_asp_net_log('prev '+ Result.m_sequence.ToString);
              l_c_stream_reader.Close;
            end
          else begin
              write_to_asp_net_log('new_data');
              l_c_stream:= FileStream.Create(k_full_file_name,
                    FileMode.Create, FileAccess.ReadWrite);

              // -- initialize the data log
              Result.m_sequence:= 0;
            end;

        // -- if does not reopen, cannot write ?
        l_c_stream.Close();
        l_c_stream:= FileStream.Create(k_full_file_name,
             FileMode.Open, FileAccess.Write);

        // -- update the data
        l_data_log:= Result;
        Inc(l_data_log.m_sequence);

        write_to_asp_net_log('will_write '+ l_data_log.m_sequence.ToString);
        l_c_stream_writer:= BinaryWriter.Create(l_c_stream);
        l_c_stream_writer.BaseStream.Seek(0, SeekOrigin.Begin);
        l_c_stream_writer.Write(l_data_log.m_sequence);
        l_c_stream_writer.Close;

        l_c_stream.Close();
      end; // do_write_log

  end.


